#include "../include/TrackerUtils.h"
#include "../include/ConcurrentQueue.h"
#include "../include/Track.h"
#include <iostream>
#include <unordered_map>
#include <thread>
#include <chrono>
#include <utility>

void TrackerUtils::track(const shared_ptr<ConcurrentQueue<Track>> &t_test) {
    bool running = true;
    unordered_map<string, int> urls;

    while (running) {
        auto [Ip, UserAgent] = t_test->wait_and_pop();

        urls[UserAgent]++;

        system("clear");
        print(urls);

        if (Ip == "STOP") {
            running = false;
        }
    }
}

void TrackerUtils::print(unordered_map<string, int> tracks) {
    for (auto it = tracks.begin(); it != tracks.end(); ++it) {
        cerr << it->first << ": " << it->second << endl;
    }

    this_thread::sleep_for(chrono::milliseconds(250));
}
